# Account Changes Testplan

&nbsp;

## Background
This testplan is going to cover the new Free Trial period functionality. It will cover transitioning from perpetually free accounts to a 30-day free trial model

&nbsp;

&nbsp;

| Test Scenario                        | Test Cases                                                         | Description                                                                                                                                                                                                                                                                                                                                                                                         | Comments |
|--------------------------------------|--------------------------------------------------------------------|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|----------|
|                                      |                                                                    |                                                                                                                                                                                                                                                                                                                                                                                                     |          |
| New user on Storj.                   | 1. Default parameters.                                             | Free trial duration - 30 days. Storage -25 GB. Egress - 25 GB                                                                                                                                                                                                                                                                                |          |
|                                      | 2. Coupon absence.                                                 | Coupon is not applied. No Coupon placeholder on the Billing page                                                                                                                                                                                                                                                                               |          |
| Already existed user.                | 3. Existed user impact.                                            | For current customers, the free tier  will be sunsetting. We will email all users who are on the free trial four times: A 30-day notice, a 15-day notice, and a final notice on the final day.                                                                                                                                                                                                                                                                                                              |          |
| Trial period configuration.          | 4. Trial period configuration - period changes.                    | Only new users should be affected.                                                                                                                                                                                                                                                                                                              |          |
|                                      | 5. Trial period limits changes.                                    | Only new users should be affected.                                                                                                                                                                                                                                                                                      |          |
| Migration.                           | 6. Migration command.                                              | Command should affect Free tier users. users should have trial_expiration, which can be in the future. After that date passes the freeze chore should freeze user's account. NOTE: not to forget - the migration which will be run first: migrate free tier users who have legacy STORJ token payments to the paid tier - that way they are not affected by the main migration. Users migrated in the migration should not receive free trial notification emails, as they are being communicated with separately from the satellite.                                                                                                                                                                                  |          |
| UI changes.                          | 7. Banner about Free Trial expiration.                             | 3 days before expiration user should see warning banner indicating how many days are left in free trial. User should see popup dialog on login.   .                                                                                                                              |          |
|                                      | 8. Banner when period Expired.                                     | After expiration user should be restricted from all use. User should see banner indicating they need to upgrade to continue using Storj. User should see popup dialog on login indicating that they need to upgrade to continue using Storj. User should see popup dialog when they try to perform actions that are locked (e.g. navigate to "browse", "team", "access keys", etc...)                                                                                                                                                                                                           |          |
|                                      | 9. Warning while upgrading to Pro.                                 | User should see banner that inform users that their free trial will end as soon as they upgrade to pro.                                                                                                                                                                                                                                                                                                                                                                                         |          |
| Post freezing behaviour.             | 10. UI.                                                            | TBD.  Will be created chore/command to delete users and their data. User can't login to deleted account.                                                                                                                                                                                                                                                                                                 |          |
|                                      | 11. Backend behaviour.                                             | TBD.  Will be created chore/command to delete users and their data. User can't login to deleted account.                                                                                                                                                                                                                                                                  |          |
| Uplink.                              | 12. Uplink after account freezing.                                 | User can't upload/download files after trial  expiration.                                                                                                                                                                                                                                                                                                   |          |
| Linksharing.                         | 13. Linksharing after trial expiration.                            | User can't share files after trial expiration. Previously created links shouldn't work.                                                                                                                                                                    |          |
| Partners.                            | 14. IX-Systems free tier users/ Pro users.                         | Only free tier users should be affected.                                                                                                                                                                                                                                                                                                                            |          |
|                                      | 15. GB-Labs free tier users/ Pro users/ GB-labs packet users.      | Only free tier users should be affected.                                                                                                   |          |
| Emails.                              | 16. Emails flow for free trial users.                              | Expected email behavior: - reminder email 3 days before expiration (should be based on same config as warning in UI); - notification email when user becomes expired. These emails should only occur for users who "naturally" enter free trial. E.g. if they created an account after config=30days. Users affected by the "free tier" -> "free trial" migration should not receive emails from the satellite. These email reminders are being handled manually by separate schedule.                                                                                                                                                                                                                                                                                                               |          |
| Invoices.                            | 17. Free tier users.                                               | Invoices shouldn't be generated for free tier users.                                                                                                                                                                                  |          |
|                                      | 18. Free trial users.                                              | Invoices shouldn't be generated for free tier users.                                                                                                                                                                                                                                                                                                                                          |          |
|                                      | 19. Pro users.                                                     | Invoices should be generated to pro users. Invoice should show an accurate start time when the user is upgraded, and only include usage that happened after upgrade.                                                                                                                                                                                                                                                                                                                                                                        |          |
